--Legal Notice: (C)2007 Altera Corporation. All rights reserved.  Your
--use of Altera Corporation's design tools, logic functions and other
--software and tools, and its AMPP partner logic functions, and any
--output files any of the foregoing (including device programming or
--simulation files), and any associated documentation or information are
--expressly subject to the terms and conditions of the Altera Program
--License Subscription Agreement or other applicable license agreement,
--including, without limitation, that your use is for the sole purpose
--of programming logic devices manufactured by Altera and sold by Altera
--or its authorized distributors.  Please refer to the applicable
--agreement for further details.


-- turn off superfluous VHDL processor warnings 
-- altera message_level Level1 
-- altera message_off 10034 10035 10036 10037 10230 10240 10030 

library altera;
use altera.altera_europa_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity spi is 
        port (
              -- inputs:
                 signal MISO : IN STD_LOGIC;
                 signal address : IN STD_LOGIC_VECTOR (23 DOWNTO 0);
                 signal chipselect : IN STD_LOGIC;
                 signal clk : IN STD_LOGIC;
                 signal read : IN STD_LOGIC;
                 signal reset : IN STD_LOGIC;
                 signal write : IN STD_LOGIC;
                 signal writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);

              -- outputs:
                 signal CS_N : OUT STD_LOGIC;
                 signal MOSI : OUT STD_LOGIC;
                 signal SCLK : OUT STD_LOGIC;
                 signal readdata : OUT STD_LOGIC_VECTOR (31 DOWNTO 0)
              );
end entity spi;


architecture europa of spi is
component spi_controller is 
           port (
                 -- inputs:
                    signal MISO : IN STD_LOGIC;
                    signal address : IN STD_LOGIC_VECTOR (23 DOWNTO 0);
                    signal chipselect : IN STD_LOGIC;
                    signal clk : IN STD_LOGIC;
                    signal read : IN STD_LOGIC;
                    signal reset : IN STD_LOGIC;
                    signal write : IN STD_LOGIC;
                    signal writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);

                 -- outputs:
                    signal CS_N : OUT STD_LOGIC;
                    signal MOSI : OUT STD_LOGIC;
                    signal SCLK : OUT STD_LOGIC;
                    signal readdata : OUT STD_LOGIC_VECTOR (31 DOWNTO 0)
                 );
end component spi_controller;

                signal internal_CS_N :  STD_LOGIC;
                signal internal_MOSI :  STD_LOGIC;
                signal internal_SCLK :  STD_LOGIC;
                signal internal_readdata :  STD_LOGIC_VECTOR (31 DOWNTO 0);

begin

  --the_spi_controller, which is an e_instance
  the_spi_controller : spi_controller
    port map(
      CS_N => internal_CS_N,
      MOSI => internal_MOSI,
      SCLK => internal_SCLK,
      readdata => internal_readdata,
      MISO => MISO,
      address => address,
      chipselect => chipselect,
      clk => clk,
      read => read,
      reset => reset,
      write => write,
      writedata => writedata
    );


  --vhdl renameroo for output signals
  CS_N <= internal_CS_N;
  --vhdl renameroo for output signals
  MOSI <= internal_MOSI;
  --vhdl renameroo for output signals
  SCLK <= internal_SCLK;
  --vhdl renameroo for output signals
  readdata <= internal_readdata;

end europa;

