-------------------------------------------------------------------------------
--
-- Inverse Mtimes Module -- Performs the mtimes calculation as part of the inverse mix columns
-- Written for 128-bit AES decryption project
-- Course: CSEE 4840 - Embedded System Design, Spring 2008
-- Authors: Shrivathsa Bhargav (sb2784)
--			Larry Chen (lc2454)
--			Abhinandan Majumdar (am2993)
--			Shiva Ramudit (syr9)
--
-- Last modified: 5-8-2008
-------------------------------------------------------------------------------

library IEEE;

use ieee.std_logic_1164.all;
use ieee.std_logic_unsigned.all;

-- Module to perform mtimes calculation - modularized to reuse parts within calculation
entity inv_mtimes is
	port (
		input : in std_logic_vector (7 downto 0);
		output : out std_logic_vector (7 downto 0)
		);
end;

architecture inv_mtimes_arch of inv_mtimes is

-- Stores it << 1 
signal temp : std_logic_vector (7 downto 0);

begin

-- Outputs out = (in << 1) || 
temp <= x"1b" when input(7) = '1' else
     (others => '0');
     
output <= (input(6 downto 0) & "0") xor temp;

end inv_mtimes_arch; 