-------------------------------------------------------------------------------
--
-- Inverse Multiply Row Module -- Part of the Mix Columns Module
-- Written for 128-bit AES decryption project
-- Course: CSEE 4840 - Embedded System Design, Spring 2008
-- Authors: Shrivathsa Bhargav (sb2784)
--			Larry Chen (lc2454)
--			Abhinandan Majumdar (am2993)
--			Shiva Ramudit (syr9)
--
-- Last modified: 5-8-2008
-------------------------------------------------------------------------------


library IEEE;
use ieee.std_logic_1164.all;
use ieee.std_logic_unsigned.all;

-- Module to perform mtimes calculation - modularized to reuse parts within calculation
entity inv_multiply_row is
	port (
		input0, input1, input2, input3 : in std_logic_vector (7 downto 0);
		const0, const1, const2, const3 : in std_logic_vector (7 downto 0);
		output: out std_logic_vector (7 downto 0)
		);
end;

architecture inv_multiply_row_arch of inv_multiply_row is

-- Store each multiplication for the output
signal term0 : std_logic_vector (7 downto 0);
signal term1 : std_logic_vector (7 downto 0);
signal term2 : std_logic_vector (7 downto 0);
signal term3 : std_logic_vector (7 downto 0);

signal mainconst : std_logic_vector (7 downto 0) := x"FF";

begin

mainconst <= mainconst;

-- (Multiply(input1, const1) ^ Multiply(input2, const2) ^ Multiply(input3, const3) ^ Multiply(input4, const4));
Calc00: entity work.inv_multiply port map(
		input => input0, const => const0, output => term0);
Calc01: entity work.inv_multiply port map(
		input => input1, const => const1, output => term1);
Calc02: entity work.inv_multiply port map(
		input => input2, const => const2, output => term2);
Calc03: entity work.inv_multiply port map(
		input => input3, const => const3, output => term3);

output <= term0 xor term1 xor term2 xor term3;

end inv_multiply_row_arch; 