-------------------------------------------------------------------------------
--
-- Expansion Keys Write Controller
-- Written for 128-bit AES decryption project
-- Course: CSEE 4840 - Embedded System Design, Spring 2008
-- Authors: Shrivathsa Bhargav (sb2784)
--			Larry Chen (lc2454)
--			Abhinandan Majumdar (am2993)
--			Shiva Ramudit (syr9)
--
-- Last modified: 5-8-2008
-------------------------------------------------------------------------------

library IEEE;
use ieee.std_logic_1164.all;
use ieee.std_logic_unsigned.all;
use ieee.std_logic_arith.all;

--Module for write-controller
entity write_controller is
port (
	clk, en : in std_logic;
	addr : out std_logic_vector(3 downto 0)
	);
end;

architecture write_controller_arch of write_controller is

type state_type is (S0, S1);
signal state : state_type := S0;

signal t_addr : std_logic_vector(3 downto 0) := "1011";

begin

process (clk) 
begin

if rising_edge(clk) then

	case state is

		-- First State - Store key in the SRAM
		when S0 =>
					if en = '1' then
						
						if t_addr = "0000" then
							state <= S1;
							t_addr <= t_addr;
						else
							t_addr <= t_addr - '1';
						end if;
						
					end if;


		-- Second State - Select Key for calculation of round key
		when S1 => 
					if en = '1' then
						state <= S1;
					elsif en = '0' then
						state <= S0;
						t_addr <= "1011";
					end if;
				            
	end case;
   

end if;

end process;


addr <= t_addr; 

end write_controller_arch;